# Creality Ender 3 Pro
### BTT SKR Mini E3 V2.0, direct drive, and BL-Touch - Raspberry Pi 4 running Klipper & Fluidd

I'm collecting information here to track progress on setting up an Ender 3 Pro that I pulled out of the trash. The previous owner had already upgraded the motherboard and completed a changeover to direct drive. The Z-axis was initially bizarrely overtightened, causing MAJOR skipping issues that squished all the prints about 30%.

After properly torquing the eccenctric nuts on the Z-axis and other belts as well as lubing everything, it printed okay! However, it had Merlin firmware which is poopy so now I'm working on converting it to Klipper. 

Before getting into the printer itself, let's go over how to connect to the Pi, which is running the whole show.

# Raspberry Pi 4
### Overview
<pre>
       _,met$$$$$gg.          ender@ender3Pro 
    ,g$$$$$$$$$$$$$$$P.       --------------- 
  ,g$$P"     """Y$$.".        OS: Debian GNU/Linux 11 (bullseye) aarch64 
 ,$$P'              `$$$.     Host: Raspberry Pi 4 Model B Rev 1.1 
',$$P       ,ggs.     `$$b:   Kernel: 6.1.21-v8+ 
`d$$'     ,$P"'   .    $$$    Uptime: 2 hours, 9 mins 
 $$P      d$'     ,    $$P    Packages: 957 (dpkg) 
 $$:      $$.   -    ,d$$'    Shell: bash 5.1.4 
 $$;      Y$b._   _,d$P'      Terminal: /dev/pts/2 
 Y$$.    `.`"Y$$$$P"'         CPU: BCM2835 (4) @ 1.500GHz 
 `$$b      "-.__              Memory: 157MiB / 3618MiB 
  `Y$$
   `Y$$.                                              
     `$$b.                                            
       `Y$$b.
          `"Y$b._
              `"""
</pre>

This machine is currently flashed with a Debian-based OS called MainsailOS - however, I do not like Mainsail so it has been gutted and replaced with Fluidd for the web interface. 

## Software

### Connecting to WiFi
On the <code>/boot/</code> partition of the SD card, create a plaintext file called <code>wpa_supplicant.conf</code> and use the following template to add the correct information for your WiFi network (this unit is compatible with both  2.4 and 5 GHz networks). Once you have created that file, re-insert the SD card (or reboot if edited in-place) and after about a minute it should appear on your WiFi network. DHCP is currently enabled. 

<pre>
# Simple configuration for a typical WPA2 network

ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev
update_config=1
country=US # US Country code

network={
        scan_ssid=1
        ssid="<Name of your wireless LAN>"
        psk="<Password for your wireless LAN>"
        proto=RSN
        key_mgmt=WPA-PSK
        pairwise=CCMP
        auth_alg=OPEN
}
</pre>

### Remote administration
Credentials to SSH into the machine are as follows:
- User: <code>ender</code>
- Password: <code>1234</code>

#### Example
<pre>
<span style="color:green"><b>steeb@thinkpadz13:~$</b></span> ssh ender@192.168.50.222
ender@192.168.50.222's password: 
Linux ender3Pro 6.1.21-v8+ #1642 SMP PREEMPT Mon Apr  3 17:24:16 BST 2023 aarch64

The programs included with the Debian GNU/Linux system are free software;
the exact distribution terms for each program are described in the
individual files in /usr/share/doc/*/copyright.

Debian GNU/Linux comes with ABSOLUTELY NO WARRANTY, to the extent
permitted by applicable law.
Last login: Fri Aug  2 14:05:21 2024 from 10.6.0.2
<span style="color:lightgreen"><b>ender@ender3Pro:~ $</b></span>
</pre>

### KIAUH (Klipper Installation and Update Helper)

I have been managing additional package for the 3d printer-specific stuff using a utility called KIAUH. You can find the Git for them [here](https://github.com/dw-0/kiauh).

You can run it using the following command:
<pre>
./kiauh/kiauh.sh
</pre>

See the Git for documentation. You probably won't need to do much through this unless you're adding new features or want to try out Mainsail instead of Fluidd. Actual updating of things is handled through the Fluidd and/or Mainsail interface.

### other

This is running a Debian-based OS. Because of this, you can update using <code>apt</code> just like on any other system. Everything that is currently installed is actively maintained and should work great through updates. On my other 2 printers running Debian w/ Klipper, updates have gone off without a hitch. 